	
var oLongUrlField 	= null;
var oTabBox		 	= null;
var oSavedTree	 	= null;
var oSavedTreeItems	= null;
var tinyurl_loaded = false;

function tinyurl_overlayInit(){
	try{
		var oContext = document.getElementById("contentAreaContextMenu");
			oContext.setAttribute("onpopupshowing", "tinyurl_contextShowing(event); "+ oContext.getAttribute("onpopupshowing"));
	} catch(err) { alert(err); }
	
	// Update all links with preview title attribute
	if(gBrowser && !tinyurl_loaded){
	
		gBrowser.addEventListener("load", function(){
			var doc = gBrowser.selectedBrowser.contentDocument;
			TinyUrl.addPreviews(doc);
		}, true);
		
		tinyurl_loaded = true;
	}
}

/**
* Load TinyUrl dialog
*/
function tinyurl_load(){
	oLongUrlField 	= document.getElementById("longurl-field");
	oTabBox			= document.getElementById("tinyurl-tabs");
	oSavedTree		= document.getElementById("saved-tree");
	oSavedTreeItems	= document.getElementById("saved-items");
	
	// Cancel button
	document.getElementById('tinyurlDialog').getButton('cancel').setAttribute("label", "Close");
	
	// Is RDF Present
	tinyurl_saved_rdfCreate();
	
	// Load Saved Data
	tinyurl_saved_read();
	
	// Preload Field
	if(opener.gBrowser && opener.gBrowser.currentURI){
		oLongUrlField.value = opener.gBrowser.currentURI.spec;
	}
	
	// Goto Save Tab
	if(window.arguments.length > 0 && window.arguments[0] == "saved"){
		oTabBox.selectedTab		= document.getElementById("tinyurl-saved-tab");
		oTabBox.selectedPanel	= document.getElementById("tinyurl-saved-tabpanel");
	}
}

/**
* Create TinyUrl from current page
*/
function tinyurl_createFromCurrent(){
	var tiny = new TinyUrl.URL(gBrowser.currentURI.spec);
	tiny.title = window._content.document.title;
	window.openDialog('chrome://tinyurl/content/create.xul','TinyUrlCreate','chrome, centerscreen, resizable', tiny);
}

/**
* Creat new Tiny Url from dialog
*/
function tinyurl_createNew(){
	try{
		
		// If not in main tab
		if(oTabBox.selectedTab.id != "tinyurl-create-tab"){
			return;
		}
		
		// Validate
		if(oLongUrlField == null || oLongUrlField.value == ""){
			alert("You have not entered a long url");
			return;
		}
		
		document.getElementById("tinyurl-field").value = "Loading...";
		
		// Title
		var sTitle = "";
		if(opener && oLongUrlField.value == opener.gBrowser.currentURI.spec){
			sTitle = opener.window._content.document.title;
		}
		
		// Get TinyUrl and Shrink
		var tiny = new TinyUrl(oLongUrlField.value);
		tiny.title = sTitle;
				
		TinyUrl.shrink(tiny, function(url){
			if(url.tiny != null){
				document.getElementById("tinyurl-field").value = url.tiny;
				document.getElementById("copy-button").disabled = false;
				document.getElementById("save-button").setAttribute("oncommand", "tinyurl_saved_add('"+ url.tiny +"', '"+ url.orig +"');");
				document.getElementById("save-button").disabled = false;
				document.getElementById('tinyurlDialogMain').style.cursor = "default";
			}
			else{
				document.getElementById("tinyurl-field").value = "";
				alert("An error occurred.\nIs your internet connection available?");
			}
		});
		
	}catch(err){ alert("Error 120\nAn unknown error occurred\n"+ err); }
}

/**
* Create TinyUrl from anchor on page
*/
function tinyurl_createFromAnchor(){		
	if(gContextMenu != null && (gContextMenu.getLinkURL || gContextMenu.linkURL)){		
		var url = (gContextMenu.getLinkURL) ? gContextMenu.getLinkURL() : gContextMenu.linkURL
		var tiny = new TinyUrl.URL(url);

		window.openDialog('chrome://tinyurl/content/create.xul','TinyUrlCreate','chrome, centerscreen, resizable', tiny);
	}
}

//Send text to tinyurl_copyText()
function tinyurl_copy(){
	try{
		var oField = document.getElementById("tinyurl-field");
		
		if(oField == null || oField.value == ""){
			return;
		}
		
		//Copy
	  	tinyurl_copyText(oField.value);
		
	}catch(err){ alert("Error 140\nCouldn't copy to clipboard"); }
}

// Comand from key stroke
function tinyurl_copy_command(){
	if(oTabBox.selectedTab.id == "tinyurl-create-tab"){
		tinyurl_copy();
	}
	else if(oTabBox.selectedTab.id == "tinyurl-saved-tab"){
		tinyurl_saved_copy();
	}
}

//Copies str to clipboard
function tinyurl_copyText(str){
	try{
		//Copy
		var oClipboard 	= Components.classes["@mozilla.org/widget/clipboardhelper;1"].getService(Components.interfaces.nsIClipboardHelper);
	  		oClipboard.copyString(str);
			
	}catch(err){ throw err }
}

// Context Showing
function tinyurl_contextShowing(event){
	try{
		if(document.popupNode.nodeName.toUpperCase() == "A"){
			document.getElementById("tinyurl-context-link-menu").setAttribute("collapsed", false);
		}
		else {
			document.getElementById("tinyurl-context-link-menu").setAttribute("collapsed", true);
		}
	} catch(e) {}
}

//Opens http://tinyurl.com
function tinyurl_gotoTinyUrl(){
	opener.focus();
	self.focus();
	
	if(opener.gBrowser.addTab)
		opener.gBrowser.selectedTab = opener.gBrowser.addTab("http://tinyurl.com");
	else
		window.open("http://tinyurl.com");
}


/**
* Manages the creation of Shrunken heads...I mean URLs
*/
var TinyUrl = {
	
	/**
	* Get the URL shrinking service the user has selected
	* @returns {TinyUrl.services.*}
	*/
	getService : function(){
		var service = TinyUrl.services.tinyurl;
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
		
		// Check preferences
		if(prefs.prefHasUserValue("tinyurl.service")){
			var name = prefs.getBoolPref("tinyurl.service");
			
			if(TinyUrl.services[name]){ // Valid?
				service = TinyUrl.services[name];
			}
		}
		
		return service;
	},
	
	
	/**
	* Shrinks the URL with the service which has been set in the preferences.
	* @param {String} url The long URL to shrink.
	* @param {Function} callback A function to call when the shrinking process is done.
	*							 + This function gets one parameters: A TinyUrl.URL details or FALSE if there was an error
	*/
	shrink : function(url, callback){
		var service = this.getService();
		service.shrink(url, callback);
	},
	
	/**
	* Add the full URL tooltip to links that have a short url service in the HREF
	* @param {Anchor} anchor The anchor tag with a TinyURL
	* @param {Document} doc The page document object
	*/
	addPreviews : function(doc){
		/*
		// Create search pattern and services hash (services[url] = serviceObj)
		var name, service;
		var pattern = [];
		var services = {};
		for(name in TinyUrl.services){
			service = TinyUrl.services[name];
			services[service.url.toLowerCase()] = service;
			pattern[pattern.length] = "("+ services.url +")";
		}
		pattern = new RegExp("^"+ pattern.join("|"), "i");
		
		// Search through anchors
		var match, anchor, url;
		var anchors = doc.getElementsByTagName("a");
		for(var i = 0; i < anchors.length; i++){
			anchor = anchors[i];
			url = anchor.href;
			
			// Match pattern?
			if( (match = url.href.match(pattern)) != null){
			
				// Find URl in service hash
				service = services[match[0].toLowerCase()];
				if(service){
				
					// Expand and update the link
					service.expand(new TinyUrl.URL(url, null, anchor), function(tinyUrl){
						if(tinyUrl.orig){
							tinyUrl.anchor.setAttribute("title", tinyUrl.orig);
						}
					});
				}
			}
		}*/
	},
	
	/**
	* For services which don't have an expand API, we can use the brute force
	* method of making a request for the URL to see where it redirects to
	* @param {TinyUrl.URL} url The short URL to expand
	* @param {Function} callback The function to call when the expanding process is done.
	*/
	expand : function(url, callback){
	
		// Setup request objects
		var io = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var uri = Components.classes["@mozilla.org/network/standard-url;1"].createInstance(Components.interfaces.nsIURI);
		uri.spec = url.tiny;
		var request = io.newChannelFromURI(uri).QueryInterface(Components.interfaces.nsIHttpChannel);
		
		request.redirectionLimit = 0;
		request.requestMethod = "HEAD";
		
		// Start request and find redirect location
		request.asyncOpen({
			onStartRequest : function(request, context){ },
			onStopRequest : function(request, context, statusCode){ 
				url.orig = request.getResponseHeader("Location");
				callback.call(request, url);
			},
			onDataAvailable : function(request, context, inputStream, offset, count){} 
		}, null);
		url.request = request;
	}
	
}

/**
* The shrunken URL details
*/
TinyUrl.URL = function(orig, tiny, anchor){

	/**
	* The original URL
	* @type {String}
	*/
	this.orig = orig;
	
	/**
	* The short URL
	* @type {String}
	*/
	this.tiny = tiny;
	
	/**
	* The anchor element with a short URL
	* @type {DomNode}
	*/
	this.anchor = anchor;
	
	
	/**
	* The title of the link or page
	* @type {String}
	*/
	this.title = "";
	
	/**
	* The XHR object processing this request
	*/
	this.request = null;
	
	/**
	* Abort the XHR request
	*/
	this.abort = function(){
		try{
			if(this.request != null){
				this.request.abort();
			}
		} catch(e){ }
	}
	
}

/**
* All the URL shrinking services this extension supports
*/
TinyUrl.services = {

	/**
	* The TinyUrl.com shrinking service
	*/
	tinyurl : {
		
		name : "TinyUrl",
		url : "http://tinyurl.com/",
		
		/**
		* @see TinyUrl.shrink() for details.
		*/
		shrink : function(url, callback){
		
			// Encode URL (TinyUrl.com will choke if you try to use encodeURIComponent)
			var urlencode = url;
			urlencode = urlencode.replace(/\+/g, "%2B");       	
			urlencode = urlencode.replace(/\?/g, '%3F');
			urlencode = urlencode.replace(/&/g, '%26');
			urlencode = urlencode.replace(/=/g, '%3D');
			
			// Setup Request
			var request	= new XMLHttpRequest();
			request.open("GET", "http://tinyurl.com/api-create.php?url="+ urlencode, true);
			request.setRequestHeader("Referer", "http://mozmonkey.com");
			
			// Handle request
			request.onload = {
				handleEvent : function(e){
					
					//Parse Response
					var tiny = request.responseText;
					if(!tiny || tiny.length > 200){
						callback.call(request, false);
						return;
					}
					
					// Notify callback function
					callback.call(request, new TinyUrl.URL(url, tiny));
				}
			};
			
			// Handle Error
			request.onerror = {
				handleEvent : function(e){
					callback.call(request, false);
				}
			}
			
			// Start Request
			request.send("");
			url.request = request;
		},
		
		/**
		* Get the full URL
		* @param {TinyUrl.URL} tiny The shrunken URL
		* @param {Function} callback
		* @return {String}
		*/
		expand : function(tiny, callback){
			TinyUrl.expand(tiny, callback);
		}
		
	},
	
	/**
	* The bit.ly shrinking service
	*/
	bitly : {
		
		name : "Bit.ly",
		url : "http://bit.ly/",
		
		/**
		* @see TinyUrl.shrink() for details.
		*/
		shrink : function(url, callback){
			var request = new XMLHttpRequest();
			request.option("GET", "http://bit.ly/api?url="+ encodeURIComponent(url));
			request.setRequestHeader("Referer", "http://mozmonkey.com");
			
			request.onload = {
				handle.event : function(evt){
					var tiny = request.responseText;
					if(!tiny || tiny.length > 200){
						callback.call(request, false);
						return;
					}
					
					// Notify callback function
					callback.call(request, new TinyUrl.URL(url, tiny));
				}
			};
			
			// Handle Error
			request.onerror = {
				handleEvent : function(e){
					callback.call(request, false);
				}
			}
			
			request.send("");
			url.request = request;
		},
		
		/**
		* Get the full URL
		* @param {TinyUrl.URL} tiny The shrunken URL
		* @param {Function} callback
		* @return {String}
		*/
		expand : function(tiny, callback){
		
			var request = new XMLHttpRequest();
			request.option("GET", "http://bit.ly/resolve?url="+ encodeURIComponent(tiny.tiny));
			request.setRequestHeader("Referer", "http://mozmonkey.com");
			
			request.onload = {
				handle.event : function(evt){
					var url = request.responseText;
					if(!url || url.length > 200){ // fail
						callback.call(request, false);
						return;
					}
					
					// Notify callback function
					tiny.orig = url;
					callback.call(request, tiny);
				}
			};
			
			// Handle Error
			request.onerror = {
				handleEvent : function(e){
					callback.call(request, false);
				}
			}
			
			request.send("");
			url.request = request;
		}
	},
	
	
	
	/**
	* The rurl.org shrinking service
	*/
	rurl : {
		
		name : "Rurl",
		url : "http://rurl.org/",
		apikey : "b512878b00efff5439688dccebbd551c",
		
		/**
		* @see TinyUrl.shrink() for details.
		*/
		shrink : function(url, callback){
		
			var request = new XMLHttpRequest();
			request.option("POST", "http://rurl.org/api/");
			request.setRequestHeader("Referer", "http://mozmonkey.com");
			
			request.onload = {
				handle.event : function(evt){
					
					// Get XML document
					var doc = request.responseXML;
					if(!doc){
						callback.call(request, false);
						return;
					}
					
					// Get tiny URL
					var tiny = doc.getElementsByTagName("url");
					if(tiny.length > 0){
						tiny = tiny[0];
						callback.call(request, new TinyUrl.URL(url, tiny));
					}
					else{
						callback.call(request, false);
					}
				}
			};
			
			// Handle Error
			request.onerror = {
				handleEvent : function(e){
					callback.call(request, false);
				}
			}
			
			request.send("url="+ encodeURIComponent(url) +"&apikey="+ this.apikey);
			url.request = request;
		},
		
		/**
		* Get the full URL
		* @param {TinyUrl.URL} tiny The shrunken URL
		* @param {Function} callback
		* @return {String}
		*/
		expand : function(tiny, callback){
			TinyUrl.expand(tiny, callback);
		}
	}
};
